﻿using System.Collections.ObjectModel;
using NavigationGrid;

using Infragistics.Controls.Grids;

namespace GroupByXamGrid
{
    public partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();

            var list = new ObservableCollection<Person>();
            for (int i = 0; i < 5; i++)
                list.Add(new Person("PersonName" + i, "PersonSurname" + i, "Ingenieur", "25", "1.77"));

            this.dtgPersons.ItemsSource = list;

            this.dtgPersons.AutoGenerateColumns = false;
            this.dtgPersons.RowHover = RowHoverType.Row;

            this.dtgPersons.SelectionSettings.CellClickAction = CellSelectionAction.SelectRow;
            this.dtgPersons.SelectionSettings.CellSelection = SelectionType.None;

            this.dtgPersons.GroupBySettings.AllowGroupByArea = GroupByAreaLocation.Top;

            this.dtgPersons.FilteringSettings.AllowFiltering = FilterUIType.FilterMenu;
            this.dtgPersons.FilteringSettings.FilteringScope = FilteringScope.ColumnLayout;

            this.dtgPersons.SortingSettings.AllowSorting = true;

            this.dtgPersons.ColumnMovingSettings.AllowColumnMoving = ColumnMovingType.Immediate;
            this.dtgPersons.ColumnMovingSettings.AnimationDuration = 20;

            this.dtgPersons.ColumnResizingSettings.AllowMultipleColumnResize = true;

            // TODO : a voir si on garde
            this.dtgPersons.ColumnResizingSettings.AllowDoubleClickToSize = true;
            this.dtgPersons.FixedColumnSettings.AllowFixedColumns = FixedColumnType.Both;

        }

        private void dtgPersons_GroupByCollectionChanged(object sender, Infragistics.Controls.Grids.GroupByCollectionChangedEventArgs e)
        {
            // We want to set the active cell to be the cell of the selected row when ungrouping:
            /*if (e.NewGroupedColumns.Count < e.PreviousGroupedColumns.Count)
            {
                if (dtgPersons.SelectionSettings.SelectedRows.Count == 1)
                {
                    this.Dispatcher.BeginInvoke(() =>
                    {
                        dtgPersons.ActiveCell = dtgPersons.SelectionSettings.SelectedRows[0].Cells[0];
                    });
                }
            }*/
        }

        private void dtgPersons_ActiveCellChanging(object sender, ActiveCellChangingEventArgs e)
        {
            // The ActiveCell can't be null.
//            if (e.NewActiveCell == null)
//                e.Cancel = true;
        }

        private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            this.dtgPersons.InvalidateData();
        }
    }
}
